﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Data.SQLite;

namespace Envelope_Index_Browser
{
    public partial class EnvIdxBrowser : Form
    {
        public EnvIdxBrowser()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            OpenFileDialog file = new OpenFileDialog();
            file.ShowDialog();

            if (file.FileName != "")
            {
                dir.Text = file.FileName;
                ShowMsgs();
            }
        }

        private void ShowMsgs()
        {
            text.Text = "";

            DataTable msgs = new DataTable();
            msgs.Columns.Add("ROWID", typeof(Int32));
            msgs.Columns.Add("sender", typeof(String));
            msgs.Columns.Add("subject", typeof(String));
            msgs.Columns.Add("_to", typeof(String));
            msgs.Columns.Add("cc", typeof(String));
            msgs.Columns.Add("date_sent", typeof(Int64));
            msgs.Columns.Add("date_received", typeof(Int64));

            SQLiteConnection sql = new SQLiteConnection("Data Source=" + dir.Text);
            sql.Open();

            SQLiteCommand cmd = sql.CreateCommand();
            cmd.CommandText = "SELECT ROWID, sender, subject, _to, cc, date_sent, date_received FROM messages ORDER BY ROWID";

            using (SQLiteDataReader reader = cmd.ExecuteReader())
            {
                while (reader.Read())
                {
                    DataRow row = msgs.NewRow();

                    row["ROWID"] = Int32.Parse(reader[0].ToString());
                    row["sender"] = reader[1].ToString();
                    row["subject"] = reader[2].ToString();
                    row["_to"] = reader[3].ToString();
                    row["cc"] = reader[4].ToString();
                    row["date_sent"] = Int64.Parse(reader[5].ToString());
                    row["date_received"] = Int64.Parse(reader[6].ToString());

                    msgs.Rows.Add(row);
                }
            }

            sql.Close();

            messages.DataSource = msgs;
        }

        private void messages_SelectionChanged(object sender, EventArgs e)
        {
/*
messages
ROWID*, sender, subject, _to, cc, date_sent, date_received

message_data
message_id*, data
    */
            text.Text = "";
            try
            {
                string id = messages.CurrentRow.Cells["ROWID"].Value.ToString();
                if (id != "")
                {
                    SQLiteConnection sql = new SQLiteConnection("Data Source=" + dir.Text);
                    sql.Open();

                    SQLiteCommand cmd = sql.CreateCommand();
                    cmd.CommandText = "SELECT length, data, part FROM message_data WHERE message_id = " + id;

                    using (SQLiteDataReader reader = cmd.ExecuteReader())
                    {
                        while (reader.Read())
                        {
                            if (text.Text != "")
                                text.Text = text.Text + "\n\n";

                            string len = reader[0].ToString();
                            if (len == "")
                            {
                                if (reader[2].ToString() == "summary")
                                    text.Text = text.Text + "=== === === SUMMARY === === ===\n";
                                text.Text = text.Text + reader[1].ToString();
                            }
                            else if (len != "1")
                            {
                                if (ru.Checked)
                                    text.Text = text.Text + Encoding.GetEncoding("windows-1251").GetString((byte[])reader[1]);
                                else
                                    text.Text = text.Text + Encoding.ASCII.GetString((byte[])reader[1]);
                            }
                        }
                    }

                    sql.Close();
                }
            }
            catch { }
        }
    }
}
